/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AmazonAdsControllerActionColumnRequestValue type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AmazonAdsControllerActionColumnRequestValue{}

// AmazonAdsControllerActionColumnRequestValue struct for AmazonAdsControllerActionColumnRequestValue
type AmazonAdsControllerActionColumnRequestValue struct {
	ReportType *string       `json:"reportType,omitempty"`
	TimeUnit   *string       `json:"timeUnit,omitempty"`
	GroupBy    []interface{} `json:"groupBy,omitempty"`
}

// NewAmazonAdsControllerActionColumnRequestValue instantiates a new AmazonAdsControllerActionColumnRequestValue object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAmazonAdsControllerActionColumnRequestValue() *AmazonAdsControllerActionColumnRequestValue {
	this := AmazonAdsControllerActionColumnRequestValue{}
	return &this
}

// NewAmazonAdsControllerActionColumnRequestValueWithDefaults instantiates a new AmazonAdsControllerActionColumnRequestValue object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAmazonAdsControllerActionColumnRequestValueWithDefaults() *AmazonAdsControllerActionColumnRequestValue {
	this := AmazonAdsControllerActionColumnRequestValue{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *AmazonAdsControllerActionColumnRequestValue) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *AmazonAdsControllerActionColumnRequestValue) SetReportType(v string) {
	o.ReportType = &v
}

// GetTimeUnit returns the TimeUnit field value if set, zero value otherwise.
func (o *AmazonAdsControllerActionColumnRequestValue) GetTimeUnit() string {
	if o == nil || IsNil(o.TimeUnit) {
		var ret string
		return ret
	}
	return *o.TimeUnit
}

// GetTimeUnitOk returns a tuple with the TimeUnit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) GetTimeUnitOk() (*string, bool) {
	if o == nil || IsNil(o.TimeUnit) {
		return nil, false
	}
	return o.TimeUnit, true
}

// HasTimeUnit returns a boolean if a field has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) HasTimeUnit() bool {
	if o != nil && !IsNil(o.TimeUnit) {
		return true
	}

	return false
}

// SetTimeUnit gets a reference to the given string and assigns it to the TimeUnit field.
func (o *AmazonAdsControllerActionColumnRequestValue) SetTimeUnit(v string) {
	o.TimeUnit = &v
}

// GetGroupBy returns the GroupBy field value if set, zero value otherwise.
func (o *AmazonAdsControllerActionColumnRequestValue) GetGroupBy() []interface{} {
	if o == nil || IsNil(o.GroupBy) {
		var ret []interface{}
		return ret
	}
	return o.GroupBy
}

// GetGroupByOk returns a tuple with the GroupBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) GetGroupByOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.GroupBy) {
		return nil, false
	}
	return o.GroupBy, true
}

// HasGroupBy returns a boolean if a field has been set.
func (o *AmazonAdsControllerActionColumnRequestValue) HasGroupBy() bool {
	if o != nil && !IsNil(o.GroupBy) {
		return true
	}

	return false
}

// SetGroupBy gets a reference to the given []interface{} and assigns it to the GroupBy field.
func (o *AmazonAdsControllerActionColumnRequestValue) SetGroupBy(v []interface{}) {
	o.GroupBy = v
}

func (o AmazonAdsControllerActionColumnRequestValue) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AmazonAdsControllerActionColumnRequestValue) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.TimeUnit) {
		toSerialize["timeUnit"] = o.TimeUnit
	}
	if !IsNil(o.GroupBy) {
		toSerialize["groupBy"] = o.GroupBy
	}
	return toSerialize, nil
}

type NullableAmazonAdsControllerActionColumnRequestValue struct {
	value *AmazonAdsControllerActionColumnRequestValue
	isSet bool
}

func (v NullableAmazonAdsControllerActionColumnRequestValue) Get() *AmazonAdsControllerActionColumnRequestValue {
	return v.value
}

func (v *NullableAmazonAdsControllerActionColumnRequestValue) Set(val *AmazonAdsControllerActionColumnRequestValue) {
	v.value = val
	v.isSet = true
}

func (v NullableAmazonAdsControllerActionColumnRequestValue) IsSet() bool {
	return v.isSet
}

func (v *NullableAmazonAdsControllerActionColumnRequestValue) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAmazonAdsControllerActionColumnRequestValue(val *AmazonAdsControllerActionColumnRequestValue) *NullableAmazonAdsControllerActionColumnRequestValue {
	return &NullableAmazonAdsControllerActionColumnRequestValue{value: val, isSet: true}
}

func (v NullableAmazonAdsControllerActionColumnRequestValue) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAmazonAdsControllerActionColumnRequestValue) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
